A deteção na Web deteta referências na Web a uma imagem.
| Categoria | Responses |
|---|---|
| Entidades Web |
|
| Imagens com correspondência total |
|
| Imagens com correspondência parcial |
|
| Páginas com imagens correspondentes |
|
| Imagens visualmente semelhantes |
|
| Etiquetas de melhor estimativa | rio carnival 2019 dancers |
Pedidos de deteção da Web
Configure o seu Google Cloud projeto e autenticação
Se não tiver criado um Google Cloud projeto, faça-o agora. Expanda esta secção para ver instruções.
-
In the Google Cloud console, on the project selector page, select or create a Google Cloud project.
Roles required to select or create a project
- Select a project: Selecting a project doesn't require a specific IAM role—you can select any project that you've been granted a role on.
-
Create a project: To create a project, you need the Project Creator role
(
roles/resourcemanager.projectCreator), which contains theresourcemanager.projects.createpermission. Learn how to grant roles.
-
Verify that billing is enabled for your Google Cloud project.
-
Enable the Vision API.
Roles required to enable APIs
To enable APIs, you need the Service Usage Admin IAM role (
roles/serviceusage.serviceUsageAdmin), which contains theserviceusage.services.enablepermission. Learn how to grant roles. -
Install the Google Cloud CLI.
-
Configure a CLI gcloud para usar a sua identidade federada.
Para mais informações, consulte o artigo Inicie sessão na CLI gcloud com a sua identidade federada.
-
Para inicializar a CLI gcloud, execute o seguinte comando:
gcloud initDetete entidades Web com uma imagem local
Pode usar a API Vision para realizar a deteção de caraterísticas num ficheiro de imagem local.
Para pedidos REST, envie o conteúdo do ficheiro de imagem como uma string codificada em base64 no corpo do pedido.
Para pedidos da
gcloude da biblioteca de cliente, especifique o caminho para uma imagem local no seu pedido.REST
Antes de usar qualquer um dos dados do pedido, faça as seguintes substituições:
- BASE64_ENCODED_IMAGE: a representação base64 (string ASCII) dos dados da imagem binária. Esta string deve ser semelhante à
seguinte string:
/9j/4QAYRXhpZgAA...9tAVx/zDQDlGxn//2Q==
- RESULTS_INT: (Opcional) Um valor inteiro de resultados a
devolver. Se omitir o campo
"maxResults"e o respetivo valor, a API devolve o valor predefinido de 10 resultados. Este campo não se aplica aos seguintes tipos de elementos:TEXT_DETECTION,DOCUMENT_TEXT_DETECTIONouCROP_HINTS. - PROJECT_ID: o ID do seu Google Cloud projeto.
Método HTTP e URL:
POST https://vision.googleapis.com/v1/images:annotate
Corpo JSON do pedido:
{ "requests": [ { "image": { "content": "BASE64_ENCODED_IMAGE" }, "features": [ { "maxResults": RESULTS_INT, "type": "WEB_DETECTION" }, ] } ] }Para enviar o seu pedido, escolha uma destas opções:
curl
Guarde o corpo do pedido num ficheiro com o nome
request.json, e execute o seguinte comando:curl -X POST \
-H "Authorization: Bearer $(gcloud auth print-access-token)" \
-H "x-goog-user-project: PROJECT_ID" \
-H "Content-Type: application/json; charset=utf-8" \
-d @request.json \
"https://vision.googleapis.com/v1/images:annotate"PowerShell
Guarde o corpo do pedido num ficheiro com o nome
request.json, e execute o seguinte comando:$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred"; "x-goog-user-project" = "PROJECT_ID" }
Invoke-WebRequest `
-Method POST `
-Headers $headers `
-ContentType: "application/json; charset=utf-8" `
-InFile request.json `
-Uri "https://vision.googleapis.com/v1/images:annotate" | Select-Object -Expand ContentSe o pedido for bem-sucedido, o servidor devolve um código de estado HTTP
200 OKe a resposta no formato JSON.Resposta:
Resposta
{ "responses": [ { "webDetection": { "webEntities": [ { "entityId": "/m/02p7_j8", "score": 1.44225, "description": "Carnival in Rio de Janeiro" }, { "entityId": "/m/06gmr", "score": 1.2913725, "description": "Rio de Janeiro" }, { "entityId": "/m/04cx88", "score": 0.78465, "description": "Brazilian Carnival" }, { "entityId": "/m/09l9f", "score": 0.7166, "description": "Carnival" }, ... ], "fullMatchingImages": [ { "url": "https://1000lugaresparair.files.wordpress.com/2017/11/quinten-de-graaf-278848.jpg" }, ... ], "partialMatchingImages": [ { "url": "https://www.linnanneito.fi/wp-content/uploads/sambakarnevaali-riossa.jpg" }, ... ], "pagesWithMatchingImages": [ { "url": "https://www.intrepidtravel.com/us/brazil/rio-carnival-122873", "pageTitle": "\u003cb\u003eRio Carnival\u003c/b\u003e | Intrepid Travel US", "partialMatchingImages": [ { "url": "https://www.intrepidtravel.com/sites/intrepid/files/styles/large/public/elements/product/hero/GGSR-Brazil-rio-carnival-ladies.jpg" }, ... ], "visuallySimilarImages": [ { "url": "https://pbs.twimg.com/media/DVoQOx6WkAIpHKF.jpg" }, ... ], "bestGuessLabels": [ { "label": "rio carnival", "languageCode": "en" } ] } } ] }Go
Antes de experimentar este exemplo, siga as Goinstruções de configuração no início rápido do Vision usando bibliotecas cliente. Para mais informações, consulte a documentação de referência da API GoVision.
Para se autenticar no Vision, configure as Credenciais padrão da aplicação. Para mais informações, consulte o artigo Configure a autenticação para um ambiente de desenvolvimento local.
// detectWeb gets image properties from the Vision API for an image at the given file path. func detectWeb(w io.Writer, file string) error { ctx := context.Background() client, err := vision.NewImageAnnotatorClient(ctx) if err != nil { return err } f, err := os.Open(file) if err != nil { return err } defer f.Close() image, err := vision.NewImageFromReader(f) if err != nil { return err } web, err := client.DetectWeb(ctx, image, nil) if err != nil { return err } fmt.Fprintln(w, "Web properties:") if len(web.FullMatchingImages) != 0 { fmt.Fprintln(w, "\tFull image matches:") for _, full := range web.FullMatchingImages { fmt.Fprintf(w, "\t\t%s\n", full.Url) } } if len(web.PagesWithMatchingImages) != 0 { fmt.Fprintln(w, "\tPages with this image:") for _, page := range web.PagesWithMatchingImages { fmt.Fprintf(w, "\t\t%s\n", page.Url) } } if len(web.WebEntities) != 0 { fmt.Fprintln(w, "\tEntities:") fmt.Fprintln(w, "\t\tEntity\t\tScore\tDescription") for _, entity := range web.WebEntities { fmt.Fprintf(w, "\t\t%-14s\t%-2.4f\t%s\n", entity.EntityId, entity.Score, entity.Description) } } if len(web.BestGuessLabels) != 0 { fmt.Fprintln(w, "\tBest guess labels:") for _, label := range web.BestGuessLabels { fmt.Fprintf(w, "\t\t%s\n", label.Label) } } return nil }Java
Antes de experimentar este exemplo, siga as instruções de configuração do Java no guia de início rápido da API Vision com bibliotecas cliente. Para mais informações, consulte a documentação de referência da API Vision Java.
import com.google.cloud.vision.v1.AnnotateImageRequest; import com.google.cloud.vision.v1.AnnotateImageResponse; import com.google.cloud.vision.v1.BatchAnnotateImagesResponse; import com.google.cloud.vision.v1.Feature; import com.google.cloud.vision.v1.Feature.Type; import com.google.cloud.vision.v1.Image; import com.google.cloud.vision.v1.ImageAnnotatorClient; import com.google.cloud.vision.v1.WebDetection; import com.google.cloud.vision.v1.WebDetection.WebEntity; import com.google.cloud.vision.v1.WebDetection.WebImage; import com.google.cloud.vision.v1.WebDetection.WebLabel; import com.google.cloud.vision.v1.WebDetection.WebPage; import com.google.protobuf.ByteString; import java.io.FileInputStream; import java.io.IOException; import java.util.ArrayList; import java.util.List; public class DetectWebDetections { public static void detectWebDetections() throws IOException { // TODO(developer): Replace these variables before running the sample. String filePath = "path/to/your/image/file.jpg"; detectWebDetections(filePath); } // Finds references to the specified image on the web. public static void detectWebDetections(String filePath) throws IOException { List<AnnotateImageRequest> requests = new ArrayList<>(); ByteString imgBytes = ByteString.readFrom(new FileInputStream(filePath)); Image img = Image.newBuilder().setContent(imgBytes).build(); Feature feat = Feature.newBuilder().setType(Type.WEB_DETECTION).build(); AnnotateImageRequest request = AnnotateImageRequest.newBuilder().addFeatures(feat).setImage(img).build(); requests.add(request); // Initialize client that will be used to send requests. This client only needs to be created // once, and can be reused for multiple requests. After completing all of your requests, call // the "close" method on the client to safely clean up any remaining background resources. try (ImageAnnotatorClient client = ImageAnnotatorClient.create()) { BatchAnnotateImagesResponse response = client.batchAnnotateImages(requests); List<AnnotateImageResponse> responses = response.getResponsesList(); for (AnnotateImageResponse res : responses) { if (res.hasError()) { System.out.format("Error: %s%n", res.getError().getMessage()); return; } // Search the web for usages of the image. You could use these signals later // for user input moderation or linking external references. // For a full list of available annotations, see http://g.co/cloud/vision/docs WebDetection annotation = res.getWebDetection(); System.out.println("Entity:Id:Score"); System.out.println("==============="); for (WebEntity entity : annotation.getWebEntitiesList()) { System.out.println( entity.getDescription() + " : " + entity.getEntityId() + " : " + entity.getScore()); } for (WebLabel label : annotation.getBestGuessLabelsList()) { System.out.format("%nBest guess label: %s", label.getLabel()); } System.out.println("%nPages with matching images: Score%n=="); for (WebPage page : annotation.getPagesWithMatchingImagesList()) { System.out.println(page.getUrl() + " : " + page.getScore()); } System.out.println("%nPages with partially matching images: Score%n=="); for (WebImage image : annotation.getPartialMatchingImagesList()) { System.out.println(image.getUrl() + " : " + image.getScore()); } System.out.println("%nPages with fully matching images: Score%n=="); for (WebImage image : annotation.getFullMatchingImagesList()) { System.out.println(image.getUrl() + " : " + image.getScore()); } System.out.println("%nPages with visually similar images: Score%n=="); for (WebImage image : annotation.getVisuallySimilarImagesList()) { System.out.println(image.getUrl() + " : " + image.getScore()); } } } } }Node.js
Antes de experimentar este exemplo, siga as Node.jsinstruções de configuração no início rápido do Vision usando bibliotecas cliente. Para mais informações, consulte a documentação de referência da API Node.jsVision.
Para se autenticar no Vision, configure as Credenciais padrão da aplicação. Para mais informações, consulte o artigo Configure a autenticação para um ambiente de desenvolvimento local.
// Imports the Google Cloud client library const vision = require('@google-cloud/vision'); // Creates a client const client = new vision.ImageAnnotatorClient(); /** * TODO(developer): Uncomment the following line before running the sample. */ // const fileName = 'Local image file, e.g. /path/to/image.png'; // Detect similar images on the web to a local file const [result] = await client.webDetection(fileName); const webDetection = result.webDetection; if (webDetection.fullMatchingImages.length) { console.log( `Full matches found: ${webDetection.fullMatchingImages.length}` ); webDetection.fullMatchingImages.forEach(image => { console.log(` URL: ${image.url}`); console.log(` Score: ${image.score}`); }); } if (webDetection.partialMatchingImages.length) { console.log( `Partial matches found: ${webDetection.partialMatchingImages.length}` ); webDetection.partialMatchingImages.forEach(image => { console.log(` URL: ${image.url}`); console.log(` Score: ${image.score}`); }); } if (webDetection.webEntities.length) { console.log(`Web entities found: ${webDetection.webEntities.length}`); webDetection.webEntities.forEach(webEntity => { console.log(` Description: ${webEntity.description}`); console.log(` Score: ${webEntity.score}`); }); } if (webDetection.bestGuessLabels.length) { console.log( `Best guess labels found: ${webDetection.bestGuessLabels.length}` ); webDetection.bestGuessLabels.forEach(label => { console.log(` Label: ${label.label}`); }); }Python
Antes de experimentar este exemplo, siga as Pythoninstruções de configuração no início rápido do Vision usando bibliotecas cliente. Para mais informações, consulte a documentação de referência da API PythonVision.
Para se autenticar no Vision, configure as Credenciais padrão da aplicação. Para mais informações, consulte o artigo Configure a autenticação para um ambiente de desenvolvimento local.
def detect_web(path): """Detects web annotations given an image.""" from google.cloud import vision client = vision.ImageAnnotatorClient() with open(path, "rb") as image_file: content = image_file.read() image = vision.Image(content=content) response = client.web_detection(image=image) annotations = response.web_detection if annotations.best_guess_labels: for label in annotations.best_guess_labels: print(f"\nBest guess label: {label.label}") if annotations.pages_with_matching_images: print( "\n{} Pages with matching images found:".format( len(annotations.pages_with_matching_images) ) ) for page in annotations.pages_with_matching_images: print(f"\n\tPage url : {page.url}") if page.full_matching_images: print( "\t{} Full Matches found: ".format(len(page.full_matching_images)) ) for image in page.full_matching_images: print(f"\t\tImage url : {image.url}") if page.partial_matching_images: print( "\t{} Partial Matches found: ".format( len(page.partial_matching_images) ) ) for image in page.partial_matching_images: print(f"\t\tImage url : {image.url}") if annotations.web_entities: print("\n{} Web entities found: ".format(len(annotations.web_entities))) for entity in annotations.web_entities: print(f"\n\tScore : {entity.score}") print(f"\tDescription: {entity.description}") if annotations.visually_similar_images: print( "\n{} visually similar images found:\n".format( len(annotations.visually_similar_images) ) ) for image in annotations.visually_similar_images: print(f"\tImage url : {image.url}") if response.error.message: raise Exception( "{}\nFor more info on error messages, check: " "https://cloud.google.com/apis/design/errors".format(response.error.message) )Idiomas adicionais
C#: Siga as instruções de configuração do C# na página das bibliotecas cliente e, em seguida, visite a documentação de referência do Vision para .NET.
PHP: Siga as instruções de configuração do PHP na página das bibliotecas cliente e, em seguida, visite a documentação de referência do Vision para PHP.
Ruby: Siga as instruções de configuração do Ruby na página das bibliotecas de cliente e, em seguida, visite a documentação de referência do Vision para Ruby.
Detete entidades Web com uma imagem remota
Pode usar a API Vision para realizar a deteção de funcionalidades num ficheiro de imagem remoto localizado no Cloud Storage ou na Web. Para enviar um pedido de ficheiro remoto, especifique o URL da Web do ficheiro ou o URI do Cloud Storage no corpo do pedido.
REST
Antes de usar qualquer um dos dados do pedido, faça as seguintes substituições:
- CLOUD_STORAGE_IMAGE_URI: o caminho para um ficheiro de imagem válido num contentor do Cloud Storage. Tem de ter, pelo menos, privilégios de leitura para o ficheiro.
Exemplo:
gs://cloud-samples-data/vision/web/carnaval.jpeg
- RESULTS_INT: (Opcional) Um valor inteiro de resultados a
devolver. Se omitir o campo
"maxResults"e o respetivo valor, a API devolve o valor predefinido de 10 resultados. Este campo não se aplica aos seguintes tipos de elementos:TEXT_DETECTION,DOCUMENT_TEXT_DETECTIONouCROP_HINTS. - PROJECT_ID: o ID do seu Google Cloud projeto.
Método HTTP e URL:
POST https://vision.googleapis.com/v1/images:annotate
Corpo JSON do pedido:
{ "requests": [ { "image": { "source": { "gcsImageUri": "CLOUD_STORAGE_IMAGE_URI" } }, "features": [ { "maxResults": RESULTS_INT, "type": "WEB_DETECTION" }, ] } ] }Para enviar o seu pedido, escolha uma destas opções:
curl
Guarde o corpo do pedido num ficheiro com o nome
request.json, e execute o seguinte comando:curl -X POST \
-H "Authorization: Bearer $(gcloud auth print-access-token)" \
-H "x-goog-user-project: PROJECT_ID" \
-H "Content-Type: application/json; charset=utf-8" \
-d @request.json \
"https://vision.googleapis.com/v1/images:annotate"PowerShell
Guarde o corpo do pedido num ficheiro com o nome
request.json, e execute o seguinte comando:$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred"; "x-goog-user-project" = "PROJECT_ID" }
Invoke-WebRequest `
-Method POST `
-Headers $headers `
-ContentType: "application/json; charset=utf-8" `
-InFile request.json `
-Uri "https://vision.googleapis.com/v1/images:annotate" | Select-Object -Expand ContentSe o pedido for bem-sucedido, o servidor devolve um código de estado HTTP
200 OKe a resposta no formato JSON.Resposta:
Resposta
{ "responses": [ { "webDetection": { "webEntities": [ { "entityId": "/m/02p7_j8", "score": 1.44225, "description": "Carnival in Rio de Janeiro" }, { "entityId": "/m/06gmr", "score": 1.2913725, "description": "Rio de Janeiro" }, { "entityId": "/m/04cx88", "score": 0.78465, "description": "Brazilian Carnival" }, { "entityId": "/m/09l9f", "score": 0.7166, "description": "Carnival" }, ... ], "fullMatchingImages": [ { "url": "https://1000lugaresparair.files.wordpress.com/2017/11/quinten-de-graaf-278848.jpg" }, ... ], "partialMatchingImages": [ { "url": "https://www.linnanneito.fi/wp-content/uploads/sambakarnevaali-riossa.jpg" }, ... ], "pagesWithMatchingImages": [ { "url": "https://www.intrepidtravel.com/us/brazil/rio-carnival-122873", "pageTitle": "\u003cb\u003eRio Carnival\u003c/b\u003e | Intrepid Travel US", "partialMatchingImages": [ { "url": "https://www.intrepidtravel.com/sites/intrepid/files/styles/large/public/elements/product/hero/GGSR-Brazil-rio-carnival-ladies.jpg" }, ... ], "visuallySimilarImages": [ { "url": "https://pbs.twimg.com/media/DVoQOx6WkAIpHKF.jpg" }, ... ], "bestGuessLabels": [ { "label": "rio carnival", "languageCode": "en" } ] } } ] }Go
Antes de experimentar este exemplo, siga as Goinstruções de configuração no início rápido do Vision usando bibliotecas cliente. Para mais informações, consulte a documentação de referência da API GoVision.
Para se autenticar no Vision, configure as Credenciais padrão da aplicação. Para mais informações, consulte o artigo Configure a autenticação para um ambiente de desenvolvimento local.
// detectWeb gets image properties from the Vision API for an image at the given file path. func detectWebURI(w io.Writer, file string) error { ctx := context.Background() client, err := vision.NewImageAnnotatorClient(ctx) if err != nil { return err } image := vision.NewImageFromURI(file) web, err := client.DetectWeb(ctx, image, nil) if err != nil { return err } fmt.Fprintln(w, "Web properties:") if len(web.FullMatchingImages) != 0 { fmt.Fprintln(w, "\tFull image matches:") for _, full := range web.FullMatchingImages { fmt.Fprintf(w, "\t\t%s\n", full.Url) } } if len(web.PagesWithMatchingImages) != 0 { fmt.Fprintln(w, "\tPages with this image:") for _, page := range web.PagesWithMatchingImages { fmt.Fprintf(w, "\t\t%s\n", page.Url) } } if len(web.WebEntities) != 0 { fmt.Fprintln(w, "\tEntities:") fmt.Fprintln(w, "\t\tEntity\t\tScore\tDescription") for _, entity := range web.WebEntities { fmt.Fprintf(w, "\t\t%-14s\t%-2.4f\t%s\n", entity.EntityId, entity.Score, entity.Description) } } if len(web.BestGuessLabels) != 0 { fmt.Fprintln(w, "\tBest guess labels:") for _, label := range web.BestGuessLabels { fmt.Fprintf(w, "\t\t%s\n", label.Label) } } return nil }Java
Antes de experimentar este exemplo, siga as Javainstruções de configuração no início rápido do Vision usando bibliotecas cliente. Para mais informações, consulte a documentação de referência da API JavaVision.
Para se autenticar no Vision, configure as Credenciais padrão da aplicação. Para mais informações, consulte o artigo Configure a autenticação para um ambiente de desenvolvimento local.
import com.google.cloud.vision.v1.AnnotateImageRequest; import com.google.cloud.vision.v1.AnnotateImageResponse; import com.google.cloud.vision.v1.BatchAnnotateImagesResponse; import com.google.cloud.vision.v1.Feature; import com.google.cloud.vision.v1.Image; import com.google.cloud.vision.v1.ImageAnnotatorClient; import com.google.cloud.vision.v1.ImageSource; import com.google.cloud.vision.v1.WebDetection; import java.io.IOException; import java.util.ArrayList; import java.util.List; public class DetectWebDetectionsGcs { public static void detectWebDetectionsGcs() throws IOException { // TODO(developer): Replace these variables before running the sample. String filePath = "gs://your-gcs-bucket/path/to/image/file.jpg"; detectWebDetectionsGcs(filePath); } // Detects whether the remote image on Google Cloud Storage has features you would want to // moderate. public static void detectWebDetectionsGcs(String gcsPath) throws IOException { List<AnnotateImageRequest> requests = new ArrayList<>(); ImageSource imgSource = ImageSource.newBuilder().setGcsImageUri(gcsPath).build(); Image img = Image.newBuilder().setSource(imgSource).build(); Feature feat = Feature.newBuilder().setType(Feature.Type.WEB_DETECTION).build(); AnnotateImageRequest request = AnnotateImageRequest.newBuilder().addFeatures(feat).setImage(img).build(); requests.add(request); // Initialize client that will be used to send requests. This client only needs to be created // once, and can be reused for multiple requests. After completing all of your requests, call // the "close" method on the client to safely clean up any remaining background resources. try (ImageAnnotatorClient client = ImageAnnotatorClient.create()) { BatchAnnotateImagesResponse response = client.batchAnnotateImages(requests); List<AnnotateImageResponse> responses = response.getResponsesList(); for (AnnotateImageResponse res : responses) { if (res.hasError()) { System.out.format("Error: %s%n", res.getError().getMessage()); return; } // Search the web for usages of the image. You could use these signals later // for user input moderation or linking external references. // For a full list of available annotations, see http://g.co/cloud/vision/docs WebDetection annotation = res.getWebDetection(); System.out.println("Entity:Id:Score"); System.out.println("==============="); for (WebDetection.WebEntity entity : annotation.getWebEntitiesList()) { System.out.println( entity.getDescription() + " : " + entity.getEntityId() + " : " + entity.getScore()); } for (WebDetection.WebLabel label : annotation.getBestGuessLabelsList()) { System.out.format("%nBest guess label: %s", label.getLabel()); } System.out.println("%nPages with matching images: Score%n=="); for (WebDetection.WebPage page : annotation.getPagesWithMatchingImagesList()) { System.out.println(page.getUrl() + " : " + page.getScore()); } System.out.println("%nPages with partially matching images: Score%n=="); for (WebDetection.WebImage image : annotation.getPartialMatchingImagesList()) { System.out.println(image.getUrl() + " : " + image.getScore()); } System.out.println("%nPages with fully matching images: Score%n=="); for (WebDetection.WebImage image : annotation.getFullMatchingImagesList()) { System.out.println(image.getUrl() + " : " + image.getScore()); } System.out.println("%nPages with visually similar images: Score%n=="); for (WebDetection.WebImage image : annotation.getVisuallySimilarImagesList()) { System.out.println(image.getUrl() + " : " + image.getScore()); } } } } }Node.js
Antes de experimentar este exemplo, siga as Node.jsinstruções de configuração no início rápido do Vision usando bibliotecas cliente. Para mais informações, consulte a documentação de referência da API Node.jsVision.
Para se autenticar no Vision, configure as Credenciais padrão da aplicação. Para mais informações, consulte o artigo Configure a autenticação para um ambiente de desenvolvimento local.
// Imports the Google Cloud client libraries const vision = require('@google-cloud/vision'); // Creates a client const client = new vision.ImageAnnotatorClient(); /** * TODO(developer): Uncomment the following lines before running the sample. */ // const bucketName = 'Bucket where the file resides, e.g. my-bucket'; // const fileName = 'Path to file within bucket, e.g. path/to/image.png'; // Detect similar images on the web to a remote file const [result] = await client.webDetection(`gs://${bucketName}/${fileName}`); const webDetection = result.webDetection; if (webDetection.fullMatchingImages.length) { console.log( `Full matches found: ${webDetection.fullMatchingImages.length}` ); webDetection.fullMatchingImages.forEach(image => { console.log(` URL: ${image.url}`); console.log(` Score: ${image.score}`); }); } if (webDetection.partialMatchingImages.length) { console.log( `Partial matches found: ${webDetection.partialMatchingImages.length}` ); webDetection.partialMatchingImages.forEach(image => { console.log(` URL: ${image.url}`); console.log(` Score: ${image.score}`); }); } if (webDetection.webEntities.length) { console.log(`Web entities found: ${webDetection.webEntities.length}`); webDetection.webEntities.forEach(webEntity => { console.log(` Description: ${webEntity.description}`); console.log(` Score: ${webEntity.score}`); }); } if (webDetection.bestGuessLabels.length) { console.log( `Best guess labels found: ${webDetection.bestGuessLabels.length}` ); webDetection.bestGuessLabels.forEach(label => { console.log(` Label: ${label.label}`); }); }Python
Antes de experimentar este exemplo, siga as Pythoninstruções de configuração no início rápido do Vision usando bibliotecas cliente. Para mais informações, consulte a documentação de referência da API PythonVision.
Para se autenticar no Vision, configure as Credenciais padrão da aplicação. Para mais informações, consulte o artigo Configure a autenticação para um ambiente de desenvolvimento local.
def detect_web_uri(uri): """Detects web annotations in the file located in Google Cloud Storage.""" from google.cloud import vision client = vision.ImageAnnotatorClient() image = vision.Image() image.source.image_uri = uri response = client.web_detection(image=image) annotations = response.web_detection if annotations.best_guess_labels: for label in annotations.best_guess_labels: print(f"\nBest guess label: {label.label}") if annotations.pages_with_matching_images: print( "\n{} Pages with matching images found:".format( len(annotations.pages_with_matching_images) ) ) for page in annotations.pages_with_matching_images: print(f"\n\tPage url : {page.url}") if page.full_matching_images: print( "\t{} Full Matches found: ".format(len(page.full_matching_images)) ) for image in page.full_matching_images: print(f"\t\tImage url : {image.url}") if page.partial_matching_images: print( "\t{} Partial Matches found: ".format( len(page.partial_matching_images) ) ) for image in page.partial_matching_images: print(f"\t\tImage url : {image.url}") if annotations.web_entities: print("\n{} Web entities found: ".format(len(annotations.web_entities))) for entity in annotations.web_entities: print(f"\n\tScore : {entity.score}") print(f"\tDescription: {entity.description}") if annotations.visually_similar_images: print( "\n{} visually similar images found:\n".format( len(annotations.visually_similar_images) ) ) for image in annotations.visually_similar_images: print(f"\tImage url : {image.url}") if response.error.message: raise Exception( "{}\nFor more info on error messages, check: " "https://cloud.google.com/apis/design/errors".format(response.error.message) )gcloud
Para realizar a deteção Web, use o comando
gcloud ml vision detect-webconforme mostrado no exemplo seguinte:gcloud ml vision detect-web gs://cloud-samples-data/vision/web/carnaval.jpeg
Idiomas adicionais
C#: Siga as instruções de configuração do C# na página das bibliotecas cliente e, em seguida, visite a documentação de referência do Vision para .NET.
PHP: Siga as instruções de configuração do PHP na página das bibliotecas cliente e, em seguida, visite a documentação de referência do Vision para PHP.
Ruby: Siga as instruções de configuração do Ruby na página das bibliotecas de cliente e, em seguida, visite a documentação de referência do Vision para Ruby.
Experimentar
Experimente a deteção de entidades Web abaixo. Pode usar a imagem já especificada (
gs://cloud-samples-data/vision/web/carnaval.jpeg) ou especificar a sua própria imagem em alternativa. Envie o pedido selecionando Executar.
Crédito da imagem: Quinten de Graaf no Unsplash. Corpo do pedido:
{ "requests": [ { "features": [ { "type": "WEB_DETECTION" } ], "image": { "source": { "gcsImageUri": "gs://cloud-samples-data/vision/web/carnaval.jpeg" } } } ] } - BASE64_ENCODED_IMAGE: a representação base64 (string ASCII) dos dados da imagem binária. Esta string deve ser semelhante à
seguinte string: